//
// QtUPDDPaintDemo
//
// logwindow.h
// Copyright 2013 Touch-Base Ltd. All Rights Reserved
//

#ifndef QTUPDDPAINTDEMO_LOGWINDOW_H
#define QTUPDDPAINTDEMO_LOGWINDOW_H

#include <QWidget>
#include <QMainWindow>
#include <QPlainTextEdit>

class LogWindow : public QMainWindow
{
	Q_OBJECT
	
public:
	explicit LogWindow(QWidget *parent = 0);
	~LogWindow();
	
private slots:
	void clearLog();
private:
	
	QPlainTextEdit *textEdit;
};

void logWindowOutputHandler(QtMsgType type, const char *msg);
void showLogWindow(QWidget *parent);
void displayInLogWindow(QString message, QColor color = Qt::black);

#endif // QTUPDDPAINTDEMO_LOGWINDOW_H
