#ifdef MACX

//#include <Carbon/Carbon.h>


//#define CRITICAL_SECTION MPSemaphoreID
#define CRITICAL_SECTION MPCriticalRegionID
#define ERROR_SUCCESS 0
#define HKEY_CURRENT_USER 0x80000001
#define HKEY_LOCAL_MACHINE 0x80000002
#define INFINITE 0xffffffff
#define TRUE 1 
#define FALSE 0
#define KEY_READ 1 
#define _tcsstr strstr
#define _tcscpy strcpy
#define _ttoi atoi
#define _tcscmp strcmp
#define _tcschr strchr
#define _tfopen fopen
#define _fgetts fgets
#define _tcslen strlen
#define _stprintf sprintf
#define _stscanf sscanf
#define _tcscat strcat
#define _tcsicmp stricmp
#define _tcsncpy strncpy 
#define _tcsncmp strncmp
#define _tcsupr strupr
#define _tcslwr strlwr
#define _fputts fputs
#define OutputDebugString printf
#define INVALID_HANDLE_VALUE 0xffffffff
#define NULL 0
#define WINAPI
typedef void VOID;
#define LONG long
#define PHKEY HKEY* 
//#define PWSTR __wchar_t* 
//#define PCWSTR const __wchar_t* 
//#define PCSZ const char* 
//#define PCSTR const char* 
//#define PBYTE unsigned char*


#define WCHAR __wchar_t
#define ERROR_MORE_DATA 234L

#define REG_SZ 1
#define REG_BINARY 3
#define REG_DWORD 4

#define MAX_PATH 256 

#undef _T
#define _T(x) x

#ifndef max
#define max(a,b)            (((a) > (b)) ? (a) : (b))
#endif


void DebugBreak(void); 

// unused parameters - these definitions exist just to keep the compiler happy
#define LPSECURITY_ATTRIBUTES int
#define GENERIC_READ 0 
#define GENERIC_WRITE 0
#define FILE_SHARE_WRITE 0
#define FILE_SHARE_READ 0 
#define OPEN_EXISTING 0
#define FILE_ATTRIBUTE_NORMAL 0
#define THREAD_PRIORITY_HIGHEST 0
#define REG_OPTION_NON_VOLATILE 0
#define KEY_ALL_ACCESS 0

// unused types - these definitions exist just to keep the compiler happy
#define FILETIME int 
#define PFILETIME int*

//int __cdecl isdigit(int);

extern "C"
{
HANDLE CreateFile(
  LPCTSTR lpFileName,                         // file name
  DWORD dwDesiredAccess,                      // access mode
  DWORD dwShareMode,                          // share mode
  LPSECURITY_ATTRIBUTES lpSecurityAttributes, // SD
  DWORD dwCreationDisposition,                // how to create
  DWORD dwFlagsAndAttributes,                 // file attributes
  HANDLE hTemplateFile                        // handle to template file
);

BOOL CloseHandle(HANDLE hObject); 

BOOL DeviceIoControl(
  HANDLE hDevice,              // handle to device
  DWORD dwIoControlCode,       // operation
  LPVOID lpInBuffer,           // input data buffer
  DWORD nInBufferSize,         // size of input data buffer
  LPVOID lpOutBuffer,          // output data buffer
  DWORD nOutBufferSize,        // size of output data buffer
  LPDWORD lpBytesReturned,     // byte count
  LPOVERLAPPED lpOverlapped    // overlapped information
);

VOID OurSleep(
  DWORD dwMilliseconds   // sleep time
);

typedef CALLBACK_API_C( OSStatus , LPTHREAD_START_ROUTINE )(void * StartContext);

/*typedef
OSStatus 
(*LPTHREAD_START_ROUTINE) (
    void* StartContext
    );*/


HANDLE CreateThread(
  LPSECURITY_ATTRIBUTES lpThreadAttributes, // SD
  DWORD dwStackSize,                        // initial stack size
  LPTHREAD_START_ROUTINE lpStartAddress,    // thread function
  LPVOID lpParameter,                       // thread argument
  DWORD dwCreationFlags,                    // creation option
  LPDWORD lpThreadId                        // thread identifier
);

BOOL SetThreadPriority(
  HANDLE hThread, // handle to the thread
  int nPriority   // thread priority level
);

DWORD WaitForSingleObject(
  HANDLE hHandle,        // handle to object
  DWORD dwMilliseconds   // time-out interval
);

LONG RegOpenKeyEx(
  HKEY hKey,         // handle to open key
  LPCTSTR lpSubKey,  // subkey name
  DWORD ulOptions,   // reserved
  int samDesired, // security access mask
  PHKEY phkResult    // handle to open key
);

LONG RegCloseKey(
  HKEY hKey   // handle to key to close
);

LONG RegQueryValueEx(
  HKEY hKey,            // handle to key
  LPCTSTR lpValueName,  // value name
  LPDWORD lpReserved,   // reserved
  LPDWORD lpType,       // type buffer
  LPBYTE lpData,        // data buffer
  LPDWORD lpcbData      // size of data buffer
);

LONG RegCreateKeyEx(
  HKEY hKey,                                  // handle to open key
  LPCTSTR lpSubKey,                           // subkey name
  DWORD Reserved,                             // reserved
  LPTSTR lpClass,                             // class string
  DWORD dwOptions,                            // special options
  int samDesired,                          // desired security access
  LPSECURITY_ATTRIBUTES lpSecurityAttributes, // inheritance
  PHKEY phkResult,                            // key handle 
  LPDWORD lpdwDisposition                     // disposition value buffer
);

LONG RegSetValueEx(
  HKEY hKey,           // handle to key
  LPCTSTR lpValueName, // value name
  DWORD Reserved,      // reserved
  DWORD dwType,        // value type
  const BYTE *lpData,  // value data
  DWORD cbData         // size of value data
);

LONG RegQueryInfoKey(
  HKEY hKey,                      // handle to key
  LPTSTR lpClass,                 // class buffer
  LPDWORD lpcClass,               // size of class buffer
  LPDWORD lpReserved,             // reserved
  LPDWORD lpcSubKeys,             // number of subkeys
  LPDWORD lpcMaxSubKeyLen,        // longest subkey name
  LPDWORD lpcMaxClassLen,         // longest class string
  LPDWORD lpcValues,              // number of value entries
  LPDWORD lpcMaxValueNameLen,     // longest value name
  LPDWORD lpcMaxValueLen,         // longest value data
  LPDWORD lpcbSecurityDescriptor, // descriptor length
  PFILETIME lpftLastWriteTime     // last write time
);

LONG RegEnumValue(
  HKEY hKey,             // handle to key to query
  DWORD dwIndex,         // index of value to query
  LPTSTR lpValueName,    // value buffer
  LPDWORD lpcValueName,  // size of value buffer
  LPDWORD lpReserved,    // reserved
  LPDWORD lpType,        // type buffer
  LPBYTE lpData,         // data buffer
  LPDWORD lpcbData       // size of data buffer
);

LONG RegEnumKeyEx(
  HKEY hKey,                  // handle to key to enumerate
  DWORD dwIndex,              // subkey index
  LPTSTR lpName,              // subkey name
  LPDWORD lpcName,            // size of subkey buffer
  LPDWORD lpReserved,         // reserved
  LPTSTR lpClass,             // class string buffer
  LPDWORD lpcClass,           // size of class string buffer
  PFILETIME lpftLastWriteTime // last write time
);

LONG RegDeleteValue(
  HKEY hKey,            // handle to key
  LPCTSTR lpValueName   // value name
);

LONG RegDeleteKey(
  HKEY hKey,         // handle to open key
  LPCTSTR lpSubKey   // subkey name
);

DWORD
GetTempPath(
    DWORD nBufferLength,
    LPSTR lpBuffer
    );

int stricmp(const char *, const char *);
char * strlwr(char *);
char * strupr(char *);

void LeaveCriticalSection(CRITICAL_SECTION *cs);
void InitializeCriticalSection(CRITICAL_SECTION *cs);
void EnterCriticalSection(CRITICAL_SECTION *cs);
void DeleteCriticalSection(CRITICAL_SECTION *cs);

}

#else

#include <semaphore.h>

#define ERROR_SUCCESS 0
#define HKEY_CURRENT_USER 0x80000001
#define HKEY_LOCAL_MACHINE 0x80000002
#define INFINITE 0xffffffff
#define TRUE 1 
#define FALSE 0
#define KEY_READ 1 
#define _tcsstr strstr
#define _tcscpy strcpy
#define _ttoi atoi
#define _itot itoa
#define _tcscmp strcmp
#define _tcschr strchr
#define _tfopen fopen
#define _fgetts fgets
#define _tcslen strlen
#define _stprintf sprintf
#define _stscanf sscanf
#define _tcscat strcat
#define _tcsicmp stricmp
#define _tcsncpy strncpy 
#define _tcsncmp strncmp
#define _tcsupr strupr
#define _tcslwr strlwr
#define _fputts fputs
#define OutputDebugString printf
#define INVALID_HANDLE_VALUE 0xffffffff
#undef NULL
#define NULL 0
#define WINAPI
typedef void VOID;
#define LONG long
#define PHKEY HKEY* 
#define CRITICAL_SECTION pthread_mutex_t
//#define PWSTR __wchar_t* 
//#define PCWSTR const __wchar_t* 
//#define PCSZ const char* 
//#define PCSTR const char* 
//#define PBYTE unsigned char*


#define WCHAR wchar_t
#define ERROR_MORE_DATA 234L

#define REG_SZ 1
#define REG_BINARY 3
#define REG_DWORD 4

#define MAX_PATH 256 

#undef _T
#define _T(x) x

#ifndef max
//#define max(a,b)            (((a) > (b)) ? (a) : (b))
#endif


void DebugBreak(void); 

// unused parameters - these definitions exist just to keep the compiler happy
#define LPSECURITY_ATTRIBUTES int
#define GENERIC_READ 0 
#define GENERIC_WRITE 0
#define FILE_SHARE_WRITE 0
#define FILE_SHARE_READ 0 
#define OPEN_EXISTING 0
#define FILE_ATTRIBUTE_NORMAL 0
#define THREAD_PRIORITY_HIGHEST 0
#define REG_OPTION_NON_VOLATILE 0
#define KEY_ALL_ACCESS 0

// unused types - these definitions exist just to keep the compiler happy
#define FILETIME int 
#define PFILETIME int*

//int __cdecl isdigit(int);

extern "C"
{
HANDLE CreateFile(
  LPCTSTR lpFileName,                         // file name
  DWORD dwDesiredAccess,                      // access mode
  DWORD dwShareMode,                          // share mode
  LPSECURITY_ATTRIBUTES lpSecurityAttributes, // SD
  DWORD dwCreationDisposition,                // how to create
  DWORD dwFlagsAndAttributes,                 // file attributes
  HANDLE hTemplateFile                        // handle to template file
);

BOOL CloseHandle(HANDLE hObject); 

BOOL DeviceIoControl(
  HANDLE hDevice,              // handle to device
  DWORD dwIoControlCode,       // operation
  LPVOID lpInBuffer,           // input data buffer
  DWORD nInBufferSize,         // size of input data buffer
  LPVOID lpOutBuffer,          // output data buffer
  DWORD nOutBufferSize,        // size of output data buffer
  LPDWORD lpBytesReturned,     // byte count
  LPOVERLAPPED lpOverlapped    // overlapped information
);

VOID OurSleep(
  DWORD dwMilliseconds   // sleep time
);

typedef
void *
(*PKSTART_ROUTINE) (
    void* StartContext
    );

// This is because a Zytronic customer had a link issue where another library
// they were using has a function called CreateThread
#define CreateThread TBApi_CreateThread

HANDLE CreateThread(
  LPSECURITY_ATTRIBUTES lpThreadAttributes, // SD
  DWORD dwStackSize,                        // initial stack size
  PKSTART_ROUTINE lpStartAddress,    // thread function
  LPVOID lpParameter,                       // thread argument
  DWORD dwCreationFlags,                    // creation option
  LPDWORD lpThreadId                        // thread identifier
);

BOOL SetThreadPriority(
  HANDLE hThread, // handle to the thread
  int nPriority   // thread priority level
);

DWORD WaitForSingleObject(
  HANDLE hHandle,        // handle to object
  DWORD dwMilliseconds   // time-out interval
);

LONG RegOpenKeyEx(
  HKEY hKey,         // handle to open key
  LPCTSTR lpSubKey,  // subkey name
  DWORD ulOptions,   // reserved
  int samDesired, // security access mask
  PHKEY phkResult    // handle to open key
);

LONG RegCloseKey(
  HKEY hKey   // handle to key to close
);

LONG RegQueryValueEx(
  HKEY hKey,            // handle to key
  LPCTSTR lpValueName,  // value name
  LPDWORD lpReserved,   // reserved
  LPDWORD lpType,       // type buffer
  LPBYTE lpData,        // data buffer
  LPDWORD lpcbData      // size of data buffer
);

LONG RegCreateKeyEx(
  HKEY hKey,                                  // handle to open key
  LPCTSTR lpSubKey,                           // subkey name
  DWORD Reserved,                             // reserved
  LPTSTR lpClass,                             // class string
  DWORD dwOptions,                            // special options
  int samDesired,                          // desired security access
  LPSECURITY_ATTRIBUTES lpSecurityAttributes, // inheritance
  PHKEY phkResult,                            // key handle 
  LPDWORD lpdwDisposition                     // disposition value buffer
);

LONG RegSetValueEx(
  HKEY hKey,           // handle to key
  LPCTSTR lpValueName, // value name
  DWORD Reserved,      // reserved
  DWORD dwType,        // value type
  const BYTE *lpData,  // value data
  DWORD cbData         // size of value data
);

LONG RegQueryInfoKey(
  HKEY hKey,                      // handle to key
  LPTSTR lpClass,                 // class buffer
  LPDWORD lpcClass,               // size of class buffer
  LPDWORD lpReserved,             // reserved
  LPDWORD lpcSubKeys,             // number of subkeys
  LPDWORD lpcMaxSubKeyLen,        // longest subkey name
  LPDWORD lpcMaxClassLen,         // longest class string
  LPDWORD lpcValues,              // number of value entries
  LPDWORD lpcMaxValueNameLen,     // longest value name
  LPDWORD lpcMaxValueLen,         // longest value data
  LPDWORD lpcbSecurityDescriptor, // descriptor length
  PFILETIME lpftLastWriteTime     // last write time
);

LONG RegEnumValue(
  HKEY hKey,             // handle to key to query
  DWORD dwIndex,         // index of value to query
  LPTSTR lpValueName,    // value buffer
  LPDWORD lpcValueName,  // size of value buffer
  LPDWORD lpReserved,    // reserved
  LPDWORD lpType,        // type buffer
  LPBYTE lpData,         // data buffer
  LPDWORD lpcbData       // size of data buffer
);

LONG RegEnumKeyEx(
  HKEY hKey,                  // handle to key to enumerate
  DWORD dwIndex,              // subkey index
  LPTSTR lpName,              // subkey name
  LPDWORD lpcName,            // size of subkey buffer
  LPDWORD lpReserved,         // reserved
  LPTSTR lpClass,             // class string buffer
  LPDWORD lpcClass,           // size of class string buffer
  PFILETIME lpftLastWriteTime // last write time
);

LONG RegDeleteValue(
  HKEY hKey,            // handle to key
  LPCTSTR lpValueName   // value name
);

LONG RegDeleteKey(
  HKEY hKey,         // handle to open key
  LPCTSTR lpSubKey   // subkey name
);

DWORD
GetTempPath(
    DWORD nBufferLength,
    LPSTR lpBuffer
    );

int stricmp(const char *, const char *);
char * strlwr(char *);
char * strupr(char *);
}

void LeaveCriticalSection(CRITICAL_SECTION *cs);
void InitializeCriticalSection(CRITICAL_SECTION *cs);
void EnterCriticalSection(CRITICAL_SECTION *cs);
void DeleteCriticalSection(CRITICAL_SECTION *cs);

bool CopyFileA(char *aFrom, char *aTo, bool aNull);

#ifndef max
#define max(a,b)            (((a) > (b)) ? (a) : (b))
#endif

#endif
