#-------------------------------------------------
#
# Project created by QtCreator 2011-12-02T16:50:50
#
#-------------------------------------------------

QT       += core gui
greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = QtUPDDPaintDemo
TEMPLATE = app


SOURCES += main.cpp\
        qtupddpaintdemo.cpp \
    qpaintwidget.cpp \
    TBReceiver.cpp \
    utilities.cpp \
    logwindow.cpp


HEADERS  += qtupddpaintdemo.h \
    qpaintwidget.h \
    TBReceiver.h \
    TBAnalysisPlatform.h \
    TBAnalysis.h \
    utilities.h \
    logwindow.h \

FORMS    += qtupddpaintdemo.ui

macx {
    LIBS += -L$$PWD/mac \
            -L/usr/local/lib \
            -ltbapi \
            -lACE \
            -framework Carbon
    INCLUDEPATH += $$PWD/mac
    DEPENDPATH += $$PWD/mac
    CONFIG -= x86_64
    CONFIG += x86
}

unix:!macx {
    LIBS += -L/opt/tbupddlx \
            -ltbapi32 \
            -lACE-5.6.2 \

    INCLUDEPATH += /opt/tbupddlx
}

win32 {
    !contains(QMAKE_HOST.arch, x86_64) {
        # 32-bit Windows:
        LIBS += -L$$PWD/win32/ -lTBApi
        INCLUDEPATH += $$PWD/win32
        DEPENDPATH += $$PWD/win32
        DEFINES += TBAPIDLL_IMPORTS
    } else {
        # 64-bit Windows:
        LIBS += -L$$PWD/win64/ -lTBApi
        INCLUDEPATH += $$PWD/win64
        DEPENDPATH += $$PWD/win64
        DEFINES += TBAPIDLL_IMPORTS
    }
}

INCLUDEPATH += $$PWD/win32
DEPENDPATH += $$PWD/win32
