//
// QtUPDDPaintDemo
//
// qtupddpaintdemo.cpp
// Copyright 2013 Touch-Base Ltd. All Rights Reserved
//

#include <QDebug>
#include <QAction>
#include <QMenuBar>
#include <QMenu>

#include "qtupddpaintdemo.h"
#include "ui_qtupddpaintdemo.h"
#include "TBReceiver.h"
#include "logWindow.h"

QtUPDDPaintDemo::QtUPDDPaintDemo(QWidget *parent) :
	QMainWindow(parent),
	ui(new Ui::QtUPDDPaintDemo)
{
	ui->setupUi(this);
	QString windowTitle = QString("Qt UPDD Paint Demo (") + QString(169) + QString("2013 Touch-Base Ltd.)");
	this->setWindowTitle(windowTitle);
	ui->paintWidget->setTouchLabel("UPDD Stylus");
	
	TBInitialize(ui->paintWidget);
}

QtUPDDPaintDemo::~QtUPDDPaintDemo()
{
	TBDeinitialize();
	delete ui;
}

void QtUPDDPaintDemo::on_actionLog_Window_triggered()
{
	showLogWindow(this);
}
